import React from 'react'
import PropTypes from 'prop-types'
import _ from 'lodash'

import './styles.css'

const highlightText = (text, searchString, highlightedClass) =>
    text && {
        __html: searchString === ''
            ? text
            : text.replace(
                new RegExp(`(${searchString})`, 'gi'),
                `<span class="${highlightedClass}">$&</span>`
            )
    }

export const HighlightedText = (props) => {
    const newProps = _.omit(props, ['text', 'searchString', 'highlightedClass'])
    const highlightedText = highlightText(props.text, props.searchString, props.highlightedClass)
    return !highlightedText ? null :
    <span
        {...newProps}
        dangerouslySetInnerHTML={highlightedText} // eslint-disable-line react/no-danger
    />
}

HighlightedText.propTypes = {
    text: PropTypes.string,
    searchString: PropTypes.string,
    highlightedClass: PropTypes.string
}

HighlightedText.defaultProps = {
    text: '',
    searchString: '',
    highlightedClass: 'defaulthighlightedClass',
    className: 'defaultClass'
}
